package cn.com.ctop.kuaishou.modules.batch.controller;

import cn.com.ctop.common.module.annotation.AutoLog;
import cn.com.ctop.common.module.utils.StringUtils;
import cn.com.ctop.kuaishou.modules.batch.entity.KuaiShouAppCreate;
import cn.com.ctop.kuaishou.modules.batch.service.IKuaiShouAppCreateService;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import lombok.extern.slf4j.Slf4j;
import org.jeecg.common.api.vo.Result;
import org.jeecg.common.system.query.QueryGenerator;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import javax.servlet.http.HttpServletRequest;
import java.util.Arrays;

/**
 * @Description: 创建应用
 * @Author: jeecg-boot
 * @Date: 2019-07-26
 * @Version: V1.0
 */
@Slf4j
@Api(tags = "创建应用")
@RestController
@RequestMapping("/kuaishou/kuaiShouAppCreate")
public class KuaiShouAppCreateController {
    @Autowired
    private IKuaiShouAppCreateService kuaiShouAppCreateService;

    /**
     * 分页列表查询
     *
     * @param kuaiShouAppCreate
     * @param pageNo
     * @param pageSize
     * @param req
     * @return
     */
    @AutoLog(value = "创建应用-分页列表查询")
    @ApiOperation(value = "创建应用-分页列表查询", notes = "创建应用-分页列表查询")
    @GetMapping(value = "/list")
    public Result<IPage<KuaiShouAppCreate>> queryPageList(KuaiShouAppCreate kuaiShouAppCreate,
                                                          @RequestParam(name = "pageNo", defaultValue = "1") Integer pageNo,
                                                          @RequestParam(name = "pageSize", defaultValue = "10") Integer pageSize,
                                                          HttpServletRequest req) {
        Result<IPage<KuaiShouAppCreate>> result = new Result<>();
        QueryWrapper<KuaiShouAppCreate> queryWrapper = QueryGenerator.initQueryWrapper(kuaiShouAppCreate, req.getParameterMap());
        Page<KuaiShouAppCreate> page = new Page<>(pageNo, pageSize);
        queryWrapper.orderByDesc("id");
        IPage<KuaiShouAppCreate> pageList = kuaiShouAppCreateService.page(page, queryWrapper);
        result.setSuccess(true);
        result.setResult(pageList);
        return result;
    }

    /**
     * 添加
     *
     * @param kuaiShouAppCreate
     * @return
     */
    @AutoLog(value = "创建应用-添加")
    @ApiOperation(value = "创建应用-添加", notes = "创建应用-添加")
    @PostMapping(value = "/add")
    public Result<KuaiShouAppCreate> add(@RequestBody KuaiShouAppCreate kuaiShouAppCreate) {
        Result<KuaiShouAppCreate> result = new Result<>();
        try {
            kuaiShouAppCreateService.save(kuaiShouAppCreate);
            result.success("添加成功！");
        } catch (Exception e) {
            log.error(e.getMessage(), e);
            result.error500("操作失败");
        }
        return result;
    }

    /**
     * 编辑
     *
     * @param kuaiShouAppCreate
     * @return
     */
    @AutoLog(value = "创建应用-编辑")
    @ApiOperation(value = "创建应用-编辑", notes = "创建应用-编辑")
    @PutMapping(value = "/edit")
    public Result<KuaiShouAppCreate> edit(@RequestBody KuaiShouAppCreate kuaiShouAppCreate) {
        Result<KuaiShouAppCreate> result = new Result<>();
        KuaiShouAppCreate kuaiShouAppCreateEntity = kuaiShouAppCreateService.getById(kuaiShouAppCreate.getId());
        if (kuaiShouAppCreateEntity == null) {
            result.error500("未找到对应实体");
        } else {
            boolean ok = kuaiShouAppCreateService.updateById(kuaiShouAppCreate);
            if (ok) {
                result.success("修改成功!");
            }
        }

        return result;
    }

    /**
     * 通过id删除
     *
     * @param id
     * @return
     */
    @AutoLog(value = "创建应用-通过id删除")
    @ApiOperation(value = "创建应用-通过id删除", notes = "创建应用-通过id删除")
    @DeleteMapping(value = "/delete")
    public Result<Object> delete(@RequestParam(name = "id", required = true) String id) {
        try {
            kuaiShouAppCreateService.removeById(id);
        } catch (Exception e) {
            log.error("删除失败", e.getMessage());
            return Result.error("删除失败!");
        }
        return Result.ok("删除成功!");
    }

    /**
     * 批量删除
     *
     * @param ids
     * @return
     */
    @AutoLog(value = "创建应用-批量删除")
    @ApiOperation(value = "创建应用-批量删除", notes = "创建应用-批量删除")
    @DeleteMapping(value = "/deleteBatch")
    public Result<KuaiShouAppCreate> deleteBatch(@RequestParam(name = "ids", required = true) String ids) {
        Result<KuaiShouAppCreate> result = new Result<>();
        if (ids == null || "".equals(ids.trim())) {
            result.error500("参数不识别！");
        } else {
            this.kuaiShouAppCreateService.removeByIds(Arrays.asList(ids.split(StringUtils.COMMA)));
            result.success("删除成功!");
        }
        return result;
    }

    /**
     * 通过id查询
     *
     * @param id
     * @return
     */
    @AutoLog(value = "创建应用-通过id查询")
    @ApiOperation(value = "创建应用-通过id查询", notes = "创建应用-通过id查询")
    @GetMapping(value = "/queryById")
    public Result<KuaiShouAppCreate> queryById(@RequestParam(name = "id", required = true) String id) {
        Result<KuaiShouAppCreate> result = new Result<>();
        KuaiShouAppCreate kuaiShouAppCreate = kuaiShouAppCreateService.getById(id);
        if (kuaiShouAppCreate == null) {
            result.error500("未找到对应实体");
        } else {
            result.setResult(kuaiShouAppCreate);
            result.setSuccess(true);
        }
        return result;
    }
}
